unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, dglOpenGL;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure IdleHandler(Sender: TObject; var Done : Boolean);
  private
    { Private declarations }
    procedure SetupGL;
    procedure Render;
  public
    { Public declarations }
    dc : HDC;
    hrc : HGLRC;
  end;

const
  NearClipping = 0.1;    //  
  FarClipping  = 200;    //  

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.SetupGL;
begin
  glClearColor(0.3,0.4,0.7,0.0); //   
  glEnable(GL_DEPTH_TEST); //   
  glEnable(GL_CULL_FACE); //     
end;

procedure TForm1.IdleHandler(Sender : TObject; var Done : Boolean);
begin
  Render;
  Sleep(1);
  Done := False;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  dc := GetDC(Handle); //     Form1

  // InitOpenGL  OpenGL,       
  if  not InitOpenGL then
    Application.Terminate;

  //    
  hrc := CreateRenderingContext(dc,[opDoubleBuffered],32,24,0,0,0,0);

  ActivateRenderingContext(dc,hrc); //  
  SetupGL;                          //  OpenGL
  Application.OnIdle := IdleHandler;
end;

procedure TForm1.FormResize(Sender: TObject);
var
  tmpBool : Boolean;
begin
  glViewport(0,0,ClientWidth,ClientHeight);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  gluPerspective(45.0,ClientWidth/ClientHeight,NearClipping,FarClipping);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;

  idleHandler(Sender,tmpBool);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DeactivateRenderingContext;
  DestroyRenderingContext(hrc);
  ReleaseDC(Handle,dc);
end;

procedure TForm1.Render;
begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

  glViewport(0,0,ClientWidth,ClientHeight);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  gluPerspective(45.0,ClientWidth/ClientHeight,NearClipping,FarClipping);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;

  glTranslatef(0,0,-3);

  glBegin(GL_QUADS);
    glColor3f(1,0,0); glVertex3f(-1,-1,0);
    glColor3f(0,1,0); glVertex3f(1,-1,0);
    glColor3f(0,0,1); glVertex3f(1,1,0);
    glColor3f(1,1,0); glVertex3f(-1,1,0);
  glEnd;

  SwapBuffers(dc);
end;

end.
